SystemOrganization addCategory: #'Peldan-Samples'!
SystemOrganization addCategory: #'Peldan-PDF'!
SystemOrganization addCategory: #'Peldan-parsing'!
SystemOrganization addCategory: #'Peldan-Collections'!
SystemOrganization addCategory: #'Peldan-Morphs'!

!Character methodsFor: '*peldan-testing' stamp: 'EP 2/18/2018 18:49'!
isWhitespace
	^ (Array
		with: Character cr
		with: Character space
		with: Character lf
		with: Character tab)
		includes: self! !

StringMorph subclass: #StreamContentsMorph
	instanceVariableNames: 'stream direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-Morphs'!

!StreamContentsMorph class methodsFor: 'instance creation' stamp: 'EP 2/21/2018 18:59'!
stream: aStream
	| inst |
	inst := self new.
	inst stream: aStream.
	^ inst! !

!StreamContentsMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 19:24'!
direction
	^ direction! !

!StreamContentsMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 19:27'!
direction: aString 
	direction := aString! !

!StreamContentsMorph methodsFor: 'initialization' stamp: 'EP 2/21/2018 19:26'!
initialize
	super initialize.
	direction := 'forward'! !

!StreamContentsMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 19:24'!
stream
	^ stream! !

!StreamContentsMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 19:03'!
stream: aStream 
	stream := aStream.
	self update.! !

!StreamContentsMorph methodsFor: 'updating' stamp: 'EP 2/21/2018 19:30'!
update
	self stream
		ifNil: [^ self].
	self direction = 'forward'
		ifTrue: [self contents: (self stream peek: 30)  ]
		ifFalse: [self contents: self stream peekBack asString]! !

Morph subclass: #StreamHolderMorph
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-Morphs'!

!StreamHolderMorph class methodsFor: 'instance creation' stamp: 'EP 2/20/2018 22:52'!
with: aStream
	^ self new stream: aStream	! !

!StreamHolderMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 19:22'!
step
	self stream closed not
		ifTrue: [self color: Color lightGreen]
		ifFalse: [self color: Color gray]! !

!StreamHolderMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 18:44'!
stepTime
	^ 5000! !

!StreamHolderMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 18:46'!
stream
	^ stream! !

!StreamHolderMorph methodsFor: 'accessing' stamp: 'EP 2/20/2018 22:52'!
stream: aStream
	stream := aStream.
	^ self ! !

!StreamHolderMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 19:23'!
streamPerform: aSelector 
	self stream perform: aSelector.
	self step! !

!StreamHolderMorph methodsFor: 'accessing' stamp: 'EP 2/21/2018 18:41'!
wantsSteps
	^ true! !

!SimpleButtonMorph methodsFor: '*peldan-random' stamp: 'EP 2/21/2018 19:18'!
stream
	^ (self ownerThatIsA: StreamHolderMorph) stream! !

!SimpleButtonMorph methodsFor: '*peldan-random' stamp: 'EP 2/21/2018 19:18'!
streamPerform: aSelector
	^ self stream perform: aSelector! !

!SimpleButtonMorph methodsFor: '*peldan-random' stamp: 'EP 2/19/2018 22:19'!
targetSamplePdfStream
	^ self target: Samples samplePdfFileStream! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 18:51'!
appendPdfIdPairTo: aLinkedList
	| id |
	self next: '/ID' size.
	id := self upTo: $].
	aLinkedList
		add: 'ID';
		add: id.
	self readWhitespace! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 18:49'!
appendPdfKeyValuePairsTo: aLinkedList
	(self peekForString: '/ID')
		ifTrue: [ self appendPdfIdPairTo: aLinkedList ];
		ifFalse: [ self appendPdfStandardKeyValuePairTo: aLinkedList ]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 20:16'!
appendPdfStandardKeyValuePairTo: aLinkedList 
	| key value |
	key := self readPdfDictionaryKey.
	value := self readPdfDictionaryValue.
	aLinkedList
		add: key;
		
		add: value! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 19:55'!
asPdf
	^ PDFParser on: self! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 17:25'!
goBack: anInteger 
	self position: self position - anInteger.
	^ self! !

!PositionableStream methodsFor: '*peldan-samples' stamp: 'ErikPeldan 2/16/2018 17:20'!
peek: anInteger 
	| p x |
	p := self position.
	x := self next: anInteger .
	self position: p.
	^ x! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 20:50'!
peekForString: aString 
	| n b |
	self ascii.
	n := aString size.
	b := (self next: n)
				= aString.
	self goBack: n.
	^ b! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/15/2018 22:16'!
readLine
	^ self isBinary
		ifTrue: [ self upTo: Character cr asciiValue ];
		ifFalse: [ self upTo: Character lf ]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 09:46'!
readNumber
	self ascii.
	^ IntegerParser parse: self! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 20:14'!
readPdfDictionary
	| d |
	self readString: '<<';
		 readWhitespace.
	d := self readPdfDictionaryKeyValuePairs.
	self readString: '>>'.
	self readWhitespace.
	^ d! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 16:25'!
readPdfDictionaryKey
 ^ self
		ascii;
		readString: '/';
		upTo: Character space.
		! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 20:15'!
readPdfDictionaryKeyValuePairs
	| pairs |
	pairs := SimpleLinkedList new.
	[self peek ~= $>]
		whileTrue: [self appendPdfKeyValuePairsTo: pairs].
	^ Dictionary newFromPairs: pairs! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 20:18'!
readPdfDictionaryValue
	| v |
	v := self
				upToAnyOf: (Array with: Character cr with: $>).
	self goBack: 1.
	self peek = Character cr
		ifTrue: [self next].
	^ v! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 19:40'!
readPdfSpaceCr
	| b |
	self peek = Character space
		ifTrue: [ b := true. self next ].
	self peek = Character cr
		ifTrue: [ b := true. self next ].
	b ifFalse: [ self error: 'Expected at least *some* whitespace' ].
	self readSpaces! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 22:34'!
readPdfStreamObject
	| contents p p2 |
	self readString: 'stream' , Character cr asString.
	self binary.
	p := self position.
	self upToAll: 'endstream' asByteArray.
	p2 := self position.
	self position: p.
	contents := self next: p2 - p.
	self readWhitespace.
	"self next: 'endstream' asByteArray size."
	self ascii.
	self halt.
	^ contents! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 17:22'!
readSpaces
	[ self peek = Character space ] whileTrue: [ self next ]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 20:49'!
readString: aString 
	| s |
	self ascii.
	s := self next: aString size.
	s = aString
		ifFalse: [self position: self position - 1;
				 error: 'Expected string ' , aString surroundedBySingleQuotes , ', not ' , s surroundedBySingleQuotes]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 18:43'!
readWhitespace
	self ascii.
	self peek isWhitespace
		ifFalse: [self error: 'Expected whitespace'].
	[self peek isWhitespace]
		whileTrue: [self next]! !

Object subclass: #PDFObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

Object subclass: #PDFParser
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFParser class methodsFor: 'parsing' stamp: 'ErikPeldan 2/15/2018 20:27'!
on: aBinaryFileStream
	| instance |
	instance := self new.
	instance on: aBinaryFileStream.
	^ instance! !

!PDFParser methodsFor: 'accessing' stamp: 'ErikPeldan 2/15/2018 20:22'!
header
	^ header! !

!PDFParser methodsFor: 'accessing' stamp: 'ErikPeldan 2/15/2018 20:22'!
header: anObject
	header := anObject! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/18/2018 20:08'!
on: aStream 
	| entities entity |
	entities := SimpleLinkedList new.
	aStream binary; reset.
	self parseHeader: aStream.
	[entity := self parseEntity: aStream.
	entity
		ifNil: [^ entities]
		ifNotNil: [entities add: entity]] repeat.
	! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/18/2018 20:11'!
parseEntity: aStream 
	(aStream peekForString: 'xref')
	ifTrue: [^ self parseXref: aStream ]
	ifFalse: [^ self parseObject: aStream]! !

!PDFParser methodsFor: 'parsing' stamp: 'ErikPeldan 2/15/2018 21:24'!
parseHeader: aStream
	aStream binary.
	self header: aStream readLine.
	aStream ascii.
	aStream readLine.	"Read the binary magic value header"
	! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/19/2018 22:25'!
parseObject: aStream 
	| d obj |
	aStream ascii.
	obj := self readObjectHeader: aStream.
	"TODO THERE IS NOT ALWAYS A DICTIONARY HERE!!"
	[self parseObject: obj on: aStream] whileTrue.
	aStream peek = $<
		ifTrue: [d := aStream readPdfDictionary].
	(aStream peekForString: 'stream')
		ifTrue: [aStream readPdfStreamObject].
	aStream readString: 'endobj'.
	aStream readWhitespace! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/19/2018 22:28'!
parseObject: aPDFObject on: aStream 
	| parser |
	parser := self objectParsers
				detect: [:p | p peekParse: aPDFObject on: aStream].
	parser ifNotNil: [^ parser parseObject: aPDFObject on: aStream] ifNil: [^ false]! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/18/2018 18:51'!
parseXref: aStream
	aStream readString: 'xref'.
	aStream
		readWhitespace;
		readNumber;
		readWhitespace;
		readNumber;
		readWhitespace.
	[ aStream peek isDigit ] whileTrue: [ aStream upTo: Character lf ].
	aStream
		readString: 'trailer';
		readWhitespace.
	aStream readPdfDictionary.
	aStream readString: 'startxref'.
	aStream readWhitespace.
	aStream readNumber.
	aStream readWhitespace.
	aStream readString: '%%EOF'.
	aStream
		readWhitespace.
		! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/19/2018 22:24'!
readObjectHeader: aStream 
	| n1 n2 |
	n1 := aStream readNumber.
	aStream readWhitespace.
	n2 := aStream readNumber.
	aStream readWhitespace; readString: 'obj'; readWhitespace.
	^ PDFObject new! !

Object subclass: #Samples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-Samples'!

!Samples class methodsFor: 'files' stamp: 'ErikPeldan 2/15/2018 20:47'!
samplePdfFileStream
	"Return a sample pdf file stream"
	^ FileStream readOnlyFileNamed: '/Users/peldan/Downloads/mmonth.pdf'.! !

Object subclass: #SimpleLinkedList
	instanceVariableNames: 'linkedlist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-Collections'!

!SimpleLinkedList methodsFor: 'adding' stamp: 'EP 2/18/2018 18:31'!
add: anObject 
	self linkedlist add: (StackLink with: anObject)! !

!SimpleLinkedList methodsFor: 'adding' stamp: 'EP 2/18/2018 20:15'!
at: anInteger 
	^ (self linkedlist at: anInteger) element! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EP 2/18/2018 18:38'!
collect: aBlockClosure 
	^ self linkedlist
		collect: [:aStackLink | aBlockClosure value: aStackLink element]! !

!SimpleLinkedList methodsFor: 'adding' stamp: 'EP 2/18/2018 18:32'!
initialize
	self linkedlist: (LinkedList new).
	^ self! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EP 2/18/2018 18:33'!
linkedlist

	^ linkedlist! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EP 2/18/2018 18:33'!
linkedlist: anObject

	linkedlist := anObject! !

!SimpleLinkedList methodsFor: 'adding' stamp: 'EP 2/18/2018 18:39'!
size
	^ self linkedlist size! !

NumberParser subclass: #IntegerParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-parsing'!

!IntegerParser methodsFor: 'accessing' stamp: 'EP 2/18/2018 09:44'!
allowPlusSign
	^ false! !

!IntegerParser methodsFor: 'parsing-public' stamp: 'EP 2/18/2018 09:43'!
nextNumber
	^ self nextInteger! !
